#!/usr/bin/python
import glob

def parse_test_file(file):
    requests = []
    with open(file) as f:
        content = f.readlines()
        request = None
        in_request = False
        for line in content:
            line = line.strip()
            if line.startswith('========================================Response'):
                in_request = False    
                if request.startswith('GET'):
                    request = request.strip() + '\r\n\r\n'
                requests.append(request)
            if in_request and not line.startswith('Cookie'):
                request += line.strip() + '\r\n'
            if line.startswith('========================================Request'):
                in_request = True
                request = ''            
    return requests

def remove_dups(test):
    no_dups = [test[0]]
    for request in test[1:]:
        if request == no_dups[-1]:
            continue
        no_dups.append(request)
    return no_dups

if __name__ == "__main__":

    i = 1

    for test_file in glob.glob('*_http.txt'):
        print test_file        
        requests = parse_test_file(test_file)
        if len(requests) < 2:
            continue
        out = open('test{}.http'.format(str(i).zfill(4)), 'w')
        requests = remove_dups(requests)
        for request in requests:
            out.write(request)
        out.close()        
        i += 1
           
    